﻿


var MyPage = {};



function btnAddNew_Click()
{
	ModalEditor_Reset();
	jQuery("#ModalEditor").modal("show");
}
function ModalEditor_Reset()
{
	jQuery("#ModalEditor input[name='ID']").val("");
	jQuery("#ModalEditor input[name='Name']").val("");
	jQuery("#ModalEditor textarea[name='Comments']").val("");
}
function Item_Loaded(data)
{
	// update fields/elements that need to be data-bound, but their "data-bound" attribute does not match a property of the received JSON object
}
function Items_Loaded()
{
	jQuery("#Items tbody tr").each(
			function ()
			{
				var tr = jQuery(this);
				var RecordID = tr.attr("data-record");
				tr.find("td:nth-child(1) a").click(
						function()
						{
							jQuery("#ModalEditor").modal("show");
							MyPage.EditorFields.Source(MyPage.EditorForm.ActionURL + RecordID).load();
						}
					);
				tr.find("td:nth-child(4) a").click(
						function()
						{
							if (!window.confirm("Are you sure you want to delete this segment?\n\nYou will not be able to undo this operation."))
							{
								return;
							}
							jQuery("#frmDelete input[name='SegmentID']").val(RecordID);
							jQuery("#frmDelete").submit();
						}
					);
			}
		);
}



function Page_Start()
{
	MyPage.EditorForm = jQuery("#ModalEditor form");
	MyPage.EditorForm.ActionURL = MyPage.EditorForm.attr("data-source");
	MyPage.EditorForm.ActionURL = MyPage.EditorForm.ActionURL.substring(0, MyPage.EditorForm.ActionURL.indexOf("SegmentID=") + 10);
	Nurbiosis.AjaxifyForm(MyPage.EditorForm).Target("#Items").Progress("#prgrsItems").OnSuccess(Items_Loaded);
	Nurbiosis.AjaxifyForm("#frmDelete").Target("#Items").Progress("#prgrsItems").OnSuccess(Items_Loaded);
	jQuery("#ModalEditor").on("hidden.bs.modal", ModalEditor_Reset);
	jQuery("#ModalEditor").on("shown.bs.modal", function() { jQuery("#ModalEditor input[name='Name']").focus(); });
	MyPage.EditorFields = new Nurbiosis.AjaxLoadingElement(MyPage.EditorForm).Progress("#ModalEditor progress").OnSuccess(Item_Loaded).ResponseType("json");
	Items_Loaded();
}



jQuery(Page_Start);