﻿


var MyPageDOM = {};



function btnAddNew_Click()
{
	ModalEditor_Reset();
	jQuery("#ModalEditor").modal("show");
}
function ModalEditor_Reset()
{
	jQuery("#ModalEditor input[name='ID']").val("");
	jQuery("#ModalEditor input[name='Name']").val("");
    jQuery("#ModalEditor input[name='SubCategory']").val("");
	jQuery("#ModalEditor input[name='IsDiscontinued']").prop("checked", false);
}
function Item_Loaded(data)
{
	// update fields/elements that need to be data-bound, but their "data-bound" attribute does not match a property of the received JSON object
	if (data.isDiscontinued) jQuery("#ModalEditor input[name='IsDiscontinued']").prop("checked", true);
}
function Items_Loaded()
{
	jQuery("#Items tbody tr").each(
			function ()
			{
				let tr = jQuery(this);
				let RecordID = tr.attr("data-record");
				tr.find("td:nth-child(2) a").click(
						function()
						{
							jQuery("#ModalEditor").modal("show");
							MyPageDOM.EditorFields.Source(MyPageDOM.FormActionURL + RecordID).load();
						}
					);
			}
		);
}



function Page_Start()
{
	Nurbiosis.AjaxifyForm("#ModalEditor form").Target("#Items").Progress("#prgrsItems").OnSuccess(Items_Loaded);
	jQuery("#ModalEditor").on("hidden.bs.modal", ModalEditor_Reset);
	jQuery("#ModalEditor").on("shown.bs.modal", function() { jQuery("#ModalEditor input[name='Name']").focus(); });
	jQuery("#ModalEditor input[type='checkbox']").change(
			function()
			{
				if (jQuery(this).prop("checked")) jQuery(this).val("true");
				else jQuery(this).val("false");
			}
		);
	MyPageDOM.EditorForm = jQuery("#ModalEditor form");
    MyPageDOM.FormActionURL = MyPageDOM.EditorForm.attr("data-source");
    MyPageDOM.FormActionURL = MyPageDOM.FormActionURL.substring(0, MyPageDOM.FormActionURL.indexOf("CategoryID=") + 11);
	MyPageDOM.EditorFields = new Nurbiosis.AjaxLoadingElement(MyPageDOM.EditorForm).Progress("#ModalEditor progress").OnSuccess(Item_Loaded).ResponseType("json");
	Items_Loaded();
}



jQuery(Page_Start);